<template>
  <div>
    <div class="block">
      <p
        class="digit"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        {{ days }}
      </p>
      <p
        class="text"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        Days
      </p>
    </div>
    <div class="block">
      <p
        class="digit"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        {{ hours }}
      </p>
      <p
        class="text"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        Hours
      </p>
    </div>
    <div class="block">
      <p
        class="digit"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        {{ minutes }}
      </p>
      <p
        class="text"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        Minutes
      </p>
    </div>
    <div class="block">
      <p
        class="digit"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        {{ seconds }}
      </p>
      <p
        class="text"
        v-responsive="{
          tiny: el => el.width < 400,
          small: el => el.width < 800
        }"
      >
        Seconds
      </p>
    </div>
  </div>
</template>

<script>
import { ResponsiveDirective } from "vue-responsive-components";

export default {
  name: "CountDown",
  mounted() {
    window.setInterval(() => {
      this.now = Math.trunc(new Date().getTime() / 1000);
    }, 1000);
  },

  props: {
    date: {
      type: Number
    }
  },

  data() {
    return {
      now: Math.trunc(new Date().getTime() / 1000)
    };
  },

  computed: {
    modifiedDate() {
      return Math.trunc(Date.parse(this.date) / 1000);
    },

    seconds() {
      return (this.modifiedDate - this.now) % 60;
    },

    minutes() {
      return Math.trunc((this.modifiedDate - this.now) / 60) % 60;
    },

    hours() {
      return Math.trunc((this.modifiedDate - this.now) / 60 / 60) % 24;
    },

    days() {
      return Math.trunc((this.modifiedDate - this.now) / 60 / 60 / 24);
    }
  },

  directives: {
    responsive: ResponsiveDirective
  }
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
.block {
  display: inline-flex;
  flex-direction: column;
  margin: 20px;
}

.text {
  color: #1a73bc;
  font-size: 40px;
  font-family: "Roboto Condensed", serif;
  margin-top: 10px;
  margin-bottom: 10px;
  text-align: center;
}

.text.small {
  font-size: 30px;
}

.text.tiny {
  font-size: 20px;
}

.digit {
  color: #86aacc;
  font-size: 150px;
  font-family: "Roboto", serif;
  margin: 10px;
  text-align: center;
}

.digit.small {
  font-size: 100px;
}

.digit.tiny {
  font-size: 50px;
}
</style>
